//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef FetchTypes_h
#define FetchTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/dom/FetchIPCTypes.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ChannelInfo.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HeadersEntry|
//
namespace mozilla {
namespace dom {
class HeadersEntry final
{
private:

public:
    MOZ_IMPLICIT HeadersEntry() :
        name_(),
        value_()
    {
    }

    MOZ_IMPLICIT HeadersEntry(
            const nsCString& _name,
            const nsCString& _value) :
        name_(_name),
        value_(_value)
    {
    }

    bool
    operator==(const HeadersEntry& _o) const;

    bool
    operator!=(const HeadersEntry& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    nsCString name_;
    nsCString value_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::HeadersEntry>
{
    typedef mozilla::dom::HeadersEntry paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalRequest|
//
namespace mozilla {
namespace dom {
class IPCInternalRequest final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT IPCInternalRequest() :
        method_(),
        urlList_(),
        headersGuard_(),
        headers_(),
        body_(),
        preferredAlternativeDataType_(),
        referrer_(),
        referrerPolicy_(),
        requestMode_(),
        requestCredentials_(),
        cacheMode_(),
        requestRedirect_(),
        integrity_(),
        fragment_(),
        principalInfo_(),
        bodySize_(),
        contentPolicyType_()
    {
    }

    MOZ_IMPLICIT IPCInternalRequest(
            const nsCString& _method,
            const nsTArray<nsCString>& _urlList,
            const HeadersGuardEnum& _headersGuard,
            const nsTArray<HeadersEntry>& _headers,
            const mozilla::Maybe<IPCStream>& _body,
            const int64_t& _bodySize,
            const nsCString& _preferredAlternativeDataType,
            const uint32_t& _contentPolicyType,
            const nsString& _referrer,
            const ReferrerPolicy& _referrerPolicy,
            const RequestMode& _requestMode,
            const RequestCredentials& _requestCredentials,
            const RequestCache& _cacheMode,
            const RequestRedirect& _requestRedirect,
            const nsString& _integrity,
            const nsCString& _fragment,
            const mozilla::Maybe<PrincipalInfo>& _principalInfo) :
        method_(_method),
        urlList_(_urlList),
        headersGuard_(_headersGuard),
        headers_(_headers),
        body_(_body),
        preferredAlternativeDataType_(_preferredAlternativeDataType),
        referrer_(_referrer),
        referrerPolicy_(_referrerPolicy),
        requestMode_(_requestMode),
        requestCredentials_(_requestCredentials),
        cacheMode_(_cacheMode),
        requestRedirect_(_requestRedirect),
        integrity_(_integrity),
        fragment_(_fragment),
        principalInfo_(_principalInfo),
        bodySize_(_bodySize),
        contentPolicyType_(_contentPolicyType)
    {
    }

    bool
    operator==(const IPCInternalRequest& _o) const;

    bool
    operator!=(const IPCInternalRequest& _o) const;

    nsCString&
    method()
    {
        return method_;
    }
    const nsCString&
    method() const
    {
        return method_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    mozilla::Maybe<IPCStream>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<IPCStream>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    nsCString&
    preferredAlternativeDataType()
    {
        return preferredAlternativeDataType_;
    }
    const nsCString&
    preferredAlternativeDataType() const
    {
        return preferredAlternativeDataType_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    nsString&
    referrer()
    {
        return referrer_;
    }
    const nsString&
    referrer() const
    {
        return referrer_;
    }

    ReferrerPolicy&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const ReferrerPolicy&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    RequestMode&
    requestMode()
    {
        return requestMode_;
    }
    const RequestMode&
    requestMode() const
    {
        return requestMode_;
    }

    RequestCredentials&
    requestCredentials()
    {
        return requestCredentials_;
    }
    const RequestCredentials&
    requestCredentials() const
    {
        return requestCredentials_;
    }

    RequestCache&
    cacheMode()
    {
        return cacheMode_;
    }
    const RequestCache&
    cacheMode() const
    {
        return cacheMode_;
    }

    RequestRedirect&
    requestRedirect()
    {
        return requestRedirect_;
    }
    const RequestRedirect&
    requestRedirect() const
    {
        return requestRedirect_;
    }

    nsString&
    integrity()
    {
        return integrity_;
    }
    const nsString&
    integrity() const
    {
        return integrity_;
    }

    nsCString&
    fragment()
    {
        return fragment_;
    }
    const nsCString&
    fragment() const
    {
        return fragment_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalInfo()
    {
        return principalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalInfo() const
    {
        return principalInfo_;
    }

private:
    nsCString method_;
    nsTArray<nsCString> urlList_;
    HeadersGuardEnum headersGuard_;
    nsTArray<HeadersEntry> headers_;
    mozilla::Maybe<IPCStream> body_;
    nsCString preferredAlternativeDataType_;
    nsString referrer_;
    ReferrerPolicy referrerPolicy_;
    RequestMode requestMode_;
    RequestCredentials requestCredentials_;
    RequestCache cacheMode_;
    RequestRedirect requestRedirect_;
    nsString integrity_;
    nsCString fragment_;
    mozilla::Maybe<PrincipalInfo> principalInfo_;
    int64_t bodySize_;
    uint32_t contentPolicyType_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCInternalRequest>
{
    typedef mozilla::dom::IPCInternalRequest paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalResponse|
//
namespace mozilla {
namespace dom {
class IPCInternalResponse final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::ipc::IPCChannelInfo IPCChannelInfo;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT IPCInternalResponse() :
        type_(),
        urlList_(),
        statusText_(),
        headersGuard_(),
        headers_(),
        body_(),
        errorCode_(),
        alternativeDataType_(),
        alternativeBody_(),
        channelInfo_(),
        principalInfo_(),
        bodySize_(),
        status_()
    {
    }

    MOZ_IMPLICIT IPCInternalResponse(
            const ResponseType& _type,
            const nsTArray<nsCString>& _urlList,
            const uint16_t& _status,
            const nsCString& _statusText,
            const HeadersGuardEnum& _headersGuard,
            const nsTArray<HeadersEntry>& _headers,
            const mozilla::Maybe<IPCStream>& _body,
            const int64_t& _bodySize,
            const nsresult& _errorCode,
            const nsCString& _alternativeDataType,
            const mozilla::Maybe<IPCStream>& _alternativeBody,
            const IPCChannelInfo& _channelInfo,
            const mozilla::Maybe<PrincipalInfo>& _principalInfo) :
        type_(_type),
        urlList_(_urlList),
        statusText_(_statusText),
        headersGuard_(_headersGuard),
        headers_(_headers),
        body_(_body),
        errorCode_(_errorCode),
        alternativeDataType_(_alternativeDataType),
        alternativeBody_(_alternativeBody),
        channelInfo_(_channelInfo),
        principalInfo_(_principalInfo),
        bodySize_(_bodySize),
        status_(_status)
    {
    }

    bool
    operator==(const IPCInternalResponse& _o) const;

    bool
    operator!=(const IPCInternalResponse& _o) const;

    ResponseType&
    type()
    {
        return type_;
    }
    const ResponseType&
    type() const
    {
        return type_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    uint16_t&
    status()
    {
        return status_;
    }
    const uint16_t&
    status() const
    {
        return status_;
    }

    nsCString&
    statusText()
    {
        return statusText_;
    }
    const nsCString&
    statusText() const
    {
        return statusText_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    mozilla::Maybe<IPCStream>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<IPCStream>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    nsresult&
    errorCode()
    {
        return errorCode_;
    }
    const nsresult&
    errorCode() const
    {
        return errorCode_;
    }

    nsCString&
    alternativeDataType()
    {
        return alternativeDataType_;
    }
    const nsCString&
    alternativeDataType() const
    {
        return alternativeDataType_;
    }

    mozilla::Maybe<IPCStream>&
    alternativeBody()
    {
        return alternativeBody_;
    }
    const mozilla::Maybe<IPCStream>&
    alternativeBody() const
    {
        return alternativeBody_;
    }

    IPCChannelInfo&
    channelInfo()
    {
        return channelInfo_;
    }
    const IPCChannelInfo&
    channelInfo() const
    {
        return channelInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalInfo()
    {
        return principalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalInfo() const
    {
        return principalInfo_;
    }

private:
    ResponseType type_;
    nsTArray<nsCString> urlList_;
    nsCString statusText_;
    HeadersGuardEnum headersGuard_;
    nsTArray<HeadersEntry> headers_;
    mozilla::Maybe<IPCStream> body_;
    nsresult errorCode_;
    nsCString alternativeDataType_;
    mozilla::Maybe<IPCStream> alternativeBody_;
    IPCChannelInfo channelInfo_;
    mozilla::Maybe<PrincipalInfo> principalInfo_;
    int64_t bodySize_;
    uint16_t status_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCInternalResponse>
{
    typedef mozilla::dom::IPCInternalResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef FetchTypes_h
