//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSHistory_h
#define PSHistory_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/dom/BrowsingContext.h"
#include "mozilla/dom/DocShellMessageUtils.h"
#include "mozilla/dom/MaybeNewPSHEntry.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadSHEntryData|
//
namespace mozilla {
namespace dom {
class LoadSHEntryData final
{
private:
    typedef mozilla::dom::CrossProcessSHEntry CrossProcessSHEntry;
    typedef mozilla::dom::MaybeDiscardedBrowsingContext MaybeDiscardedBrowsingContext;

public:
    MOZ_IMPLICIT LoadSHEntryData() :
        shEntry_(),
        browsingContext_(),
        loadState_()
    {
    }

    MOZ_IMPLICIT LoadSHEntryData(
            CrossProcessSHEntry* _shEntry,
            const MaybeDiscardedBrowsingContext& _browsingContext,
            nsDocShellLoadState* _loadState) :
        shEntry_(_shEntry),
        browsingContext_(_browsingContext),
        loadState_(_loadState)
    {
    }

    bool
    operator==(const LoadSHEntryData& _o) const;

    bool
    operator!=(const LoadSHEntryData& _o) const;

    RefPtr<CrossProcessSHEntry>&
    shEntry()
    {
        return shEntry_;
    }
    CrossProcessSHEntry*
    shEntry() const
    {
        return shEntry_;
    }

    MaybeDiscardedBrowsingContext&
    browsingContext()
    {
        return browsingContext_;
    }
    const MaybeDiscardedBrowsingContext&
    browsingContext() const
    {
        return browsingContext_;
    }

    RefPtr<nsDocShellLoadState>&
    loadState()
    {
        return loadState_;
    }
    nsDocShellLoadState*
    loadState() const
    {
        return loadState_;
    }

private:
    RefPtr<CrossProcessSHEntry> shEntry_;
    MaybeDiscardedBrowsingContext browsingContext_;
    RefPtr<nsDocShellLoadState> loadState_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::LoadSHEntryData>
{
    typedef mozilla::dom::LoadSHEntryData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union LoadSHEntryResult|
//
namespace mozilla {
namespace dom {
class LoadSHEntryResult final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TArrayOfLoadSHEntryData,
        T__Last = TArrayOfLoadSHEntryData
    };

private:
    typedef mozilla::dom::LoadSHEntryData LoadSHEntryData;
    typedef nsresult nsresult__tdef;
    typedef nsTArray<LoadSHEntryData> ArrayOfLoadSHEntryData__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<nsTArray<LoadSHEntryData>> VArrayOfLoadSHEntryData;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    nsTArray<LoadSHEntryData>*
    ptr_ArrayOfLoadSHEntryData()
    {
        return ((mValue).VArrayOfLoadSHEntryData).addr();
    }
    const nsTArray<LoadSHEntryData>*
    constptr_ArrayOfLoadSHEntryData() const
    {
        return ((mValue).VArrayOfLoadSHEntryData).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT LoadSHEntryResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT LoadSHEntryResult(const nsresult& aOther);

    MOZ_IMPLICIT LoadSHEntryResult(nsresult&& aOther);

    MOZ_IMPLICIT LoadSHEntryResult(const nsTArray<LoadSHEntryData>& aOther);

    MOZ_IMPLICIT LoadSHEntryResult(nsTArray<LoadSHEntryData>&& aOther);

    MOZ_IMPLICIT LoadSHEntryResult(const LoadSHEntryResult& aOther);

    MOZ_IMPLICIT LoadSHEntryResult(LoadSHEntryResult&& aOther);

    ~LoadSHEntryResult();

    Type
    type() const
    {
        return mType;
    }

    LoadSHEntryResult&
    operator=(const nsresult& aRhs);

    LoadSHEntryResult&
    operator=(nsresult&& aRhs);

    LoadSHEntryResult&
    operator=(const nsTArray<LoadSHEntryData>& aRhs);

    LoadSHEntryResult&
    operator=(nsTArray<LoadSHEntryData>&& aRhs);

    LoadSHEntryResult&
    operator=(const LoadSHEntryResult& aRhs);

    LoadSHEntryResult&
    operator=(LoadSHEntryResult&& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const nsTArray<LoadSHEntryData>& aRhs) const;

    bool
    operator==(const LoadSHEntryResult& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    nsTArray<LoadSHEntryData>&
    get_ArrayOfLoadSHEntryData()
    {
        AssertSanity(TArrayOfLoadSHEntryData);
        return (*(ptr_ArrayOfLoadSHEntryData()));
    }
    const nsTArray<LoadSHEntryData>&
    get_ArrayOfLoadSHEntryData() const
    {
        AssertSanity(TArrayOfLoadSHEntryData);
        return (*(constptr_ArrayOfLoadSHEntryData()));
    }
    void
    get(nsTArray<LoadSHEntryData>* aOutValue) const;
    operator nsTArray<LoadSHEntryData>&()
    {
        return get_ArrayOfLoadSHEntryData();
    }
    operator const nsTArray<LoadSHEntryData>&() const
    {
        return get_ArrayOfLoadSHEntryData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::LoadSHEntryResult>
{
    typedef mozilla::dom::LoadSHEntryResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PSHistoryParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PSHistoryChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PSHistoryChild and PSHistoryParent
//
namespace mozilla {
namespace dom {
namespace PSHistory {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PSHistoryParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PSHistoryChild>* aChild);

enum MessageType {
    PSHistoryStart = PSHistoryMsgStart << 16,
    Msg_GetCount__ID,
    Reply_GetCount__ID,
    Msg_GetIndex__ID,
    Reply_GetIndex__ID,
    Msg_SetIndex__ID,
    Reply_SetIndex__ID,
    Msg_GetRequestedIndex__ID,
    Reply_GetRequestedIndex__ID,
    Msg_InternalSetRequestedIndex__ID,
    Msg_GetEntryAtIndex__ID,
    Reply_GetEntryAtIndex__ID,
    Msg_PurgeHistory__ID,
    Reply_PurgeHistory__ID,
    Msg_ReloadCurrentEntry__ID,
    Reply_ReloadCurrentEntry__ID,
    Msg_GotoIndex__ID,
    Reply_GotoIndex__ID,
    Msg_GetIndexOfEntry__ID,
    Reply_GetIndexOfEntry__ID,
    Msg_AddEntry__ID,
    Reply_AddEntry__ID,
    Msg_UpdateIndex__ID,
    Msg_ReplaceEntry__ID,
    Reply_ReplaceEntry__ID,
    Msg_NotifyOnHistoryReload__ID,
    Reply_NotifyOnHistoryReload__ID,
    Msg_EvictOutOfRangeContentViewers__ID,
    Msg_EvictAllContentViewers__ID,
    Msg_RemoveDynEntries__ID,
    Msg_RemoveEntries__ID,
    Reply_RemoveEntries__ID,
    Msg_RemoveFrameEntries__ID,
    Msg_Reload__ID,
    Reply_Reload__ID,
    Msg_GetAllEntries__ID,
    Reply_GetAllEntries__ID,
    Msg_FindEntryForBFCache__ID,
    Reply_FindEntryForBFCache__ID,
    Msg_Evict__ID,
    Msg_EnsureCorrectEntryAtCurrIndex__ID,
    Msg_EvictContentViewersOrReplaceEntry__ID,
    Msg_NotifyListenersContentViewerEvicted__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ReloadCurrentEntryFromChild__ID,
    PSHistoryEnd
};

IPC::Message*
Msg_GetCount(int32_t routingId);
IPC::Message*
Reply_GetCount(int32_t routingId);

IPC::Message*
Msg_GetIndex(int32_t routingId);
IPC::Message*
Reply_GetIndex(int32_t routingId);

IPC::Message*
Msg_SetIndex(int32_t routingId);
IPC::Message*
Reply_SetIndex(int32_t routingId);

IPC::Message*
Msg_GetRequestedIndex(int32_t routingId);
IPC::Message*
Reply_GetRequestedIndex(int32_t routingId);

IPC::Message*
Msg_InternalSetRequestedIndex(int32_t routingId);

IPC::Message*
Msg_GetEntryAtIndex(int32_t routingId);
IPC::Message*
Reply_GetEntryAtIndex(int32_t routingId);

IPC::Message*
Msg_PurgeHistory(int32_t routingId);
IPC::Message*
Reply_PurgeHistory(int32_t routingId);

IPC::Message*
Msg_ReloadCurrentEntry(int32_t routingId);
IPC::Message*
Reply_ReloadCurrentEntry(int32_t routingId);

IPC::Message*
Msg_GotoIndex(int32_t routingId);
IPC::Message*
Reply_GotoIndex(int32_t routingId);

IPC::Message*
Msg_GetIndexOfEntry(int32_t routingId);
IPC::Message*
Reply_GetIndexOfEntry(int32_t routingId);

IPC::Message*
Msg_AddEntry(int32_t routingId);
IPC::Message*
Reply_AddEntry(int32_t routingId);

IPC::Message*
Msg_UpdateIndex(int32_t routingId);

IPC::Message*
Msg_ReplaceEntry(int32_t routingId);
IPC::Message*
Reply_ReplaceEntry(int32_t routingId);

IPC::Message*
Msg_NotifyOnHistoryReload(int32_t routingId);
IPC::Message*
Reply_NotifyOnHistoryReload(int32_t routingId);

IPC::Message*
Msg_EvictOutOfRangeContentViewers(int32_t routingId);

IPC::Message*
Msg_EvictAllContentViewers(int32_t routingId);

IPC::Message*
Msg_RemoveDynEntries(int32_t routingId);

IPC::Message*
Msg_RemoveEntries(int32_t routingId);
IPC::Message*
Reply_RemoveEntries(int32_t routingId);

IPC::Message*
Msg_RemoveFrameEntries(int32_t routingId);

IPC::Message*
Msg_Reload(int32_t routingId);
IPC::Message*
Reply_Reload(int32_t routingId);

IPC::Message*
Msg_GetAllEntries(int32_t routingId);
IPC::Message*
Reply_GetAllEntries(int32_t routingId);

IPC::Message*
Msg_FindEntryForBFCache(int32_t routingId);
IPC::Message*
Reply_FindEntryForBFCache(int32_t routingId);

IPC::Message*
Msg_Evict(int32_t routingId);

IPC::Message*
Msg_EnsureCorrectEntryAtCurrIndex(int32_t routingId);

IPC::Message*
Msg_EvictContentViewersOrReplaceEntry(int32_t routingId);

IPC::Message*
Msg_NotifyListenersContentViewerEvicted(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_ReloadCurrentEntryFromChild(int32_t routingId);



} // namespace PSHistory
} // namespace dom
} // namespace mozilla

#endif // ifndef PSHistory_h
